/*
 *  
 *  Copyright (c) 2004 Steve Slaven, All Rights Reserved.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA 02111-1307 USA
 *  
*/
package net.hoopajoo.cheeselab3;
import java.sql.*;
import java.util.*;
import java.io.*;

public class CheeseProxy {
	static Properties props = null;

	// This replaces the semaphore
	static private long syncid = 0;	
	static private long tiles_syncid = 0;
	static private long world_syncid = 0;
	
	public static void tiles_changed() {
		tiles_syncid++;
	}
	
	public static void world_changed() {
		world_syncid++;
	}
	
	public static void changed() {
		CheeseLab.dmesg( 2, "Increment changed" );
		syncid++;
	}
	
	public static long get_syncid() {
		return( syncid );
	}
	
	public static long get_tiles_syncid() {
		return( tiles_syncid );
	}
	
	public static long get_world_syncid() {
		return( world_syncid );
	}
	
	public static void main(String[] args) {
		// Load properties
		try {
			props = new Properties();
		    FileInputStream in = new FileInputStream( "cheeseproxy.cfg" );
		    props.load( in );
		    //props.list( System.out );
		    in.close();
		    
		}catch( Exception e ) {
			e.printStackTrace();
		}

		try {
			int loglevel = Integer.parseInt( props.getProperty( "loglevel" ) );
			CheeseLab.log_level = loglevel;
		}catch( Exception e ) {
			CheeseLab.log_level = 0;
		}
		
		try {
			// load driver
			Class.forName( "org.apache.derby.jdbc.EmbeddedDriver" );
			
			// Clear users
			CheeseLab.dmesg( 1, "Clearing user online flags and future paths..." );
			Connection db = DriverManager.getConnection( "jdbc:derby:cheesedb" );
			PreparedStatement s = db.prepareStatement( "update user_t set online=0, future=''" );
			s.executeUpdate();
			s.close();
			
			// Leave the db open, so it's loaded in memory for connections
			//db.close();
		}catch( Exception e ) {
			e.printStackTrace();
			return;
		}
		
		// Create server and player sockets
		PlayerServer ps = new PlayerServer();
		ps.start();
		BrokerServer bs = new BrokerServer();
		bs.start();
	}
}
